/*
  CRF++ -- Yet Another CRF toolkit

  $Id: common.h,v 1.7 2005/10/30 03:54:15 taku Exp $;

  Copyright (C) 2005 Taku Kudo <taku@chasen.org>

  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307	USA
*/
#ifndef CRFPP_COMMON_H
#define CRFPP_COMMON_H

#include <cstring>
#include <algorithm>

#include "fad.h"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#define COPYRIGHT  "CRF++: Yet Another CRF Tool Kit\nCopyright (C) 2005 Taku Kudo, All rights reserved.\n"
#define MODEL_VERSION 100

#if defined (_WIN32) && !defined (__CYGWIN__)
# define OUTPUT_MODE std::ios::binary|std::ios::out
#else
# define OUTPUT_MODE std::ios::out
#endif

#define WHAT(msg) _what.str(""), _what << __FILE__ << "(" << __LINE__ << "): " << msg;
#define WHAT_CLOSE_FALSE(msg) { WHAT(msg); this->close(); return false; }
#define WHAT_FALSE(msg)	      { WHAT(msg); return false; }

namespace CRFPP
{
  template <class T> inline T _min (T x, T y) { return (x < y) ? x : y; }
  template <class T> inline T _max (T x, T y) { return (x > y) ? x : y; }

  template <class Iterator>
  static inline size_t tokenize (char *str,
				 const char *del, Iterator out, size_t max)
  {
    char *stre = str + strlen (str);
    const char *dele = del + strlen (del);
    size_t size = 0;

    while (size < max) {
      char *n = std::find_first_of (str, stre, del, dele);
      *n = '\0';
      *out++ = str;
      ++size;
      if (n == stre) break;
      str = n + 1;
    }

    for (unsigned int i = size; i < max; ++i)
      *out++ = (char *)"";
    return size;
  }
}

#endif
