/*
  CRF++ -- Yet Another CRF toolkit

  $Id: feature_cache.h,v 1.5 2005/10/30 03:54:15 taku Exp $;

  Copyright (C) 2005 Taku Kudo <taku@chasen.org>

  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307	USA
*/
#ifndef CRFPP_FEATURE_CACHE_H
#define CRFPP_FEATURE_CACHE_H

#include <vector>
#include <map>
#include "freelist.h"

namespace CRFPP {

  class FeatureCache: public std::vector <int *>
  {

  private:
    size_t cur;
    FreeList<int>   feature_freelist;

  public:
    int *shift () { return (*this)[cur++]; }
    void reset () { cur = 0; }

    void clear () {
      reset();
      std::vector<int *>::clear();
      feature_freelist.free();
    }

    void add (const std::vector<int> &);
    void shrink (std::map<int,int> &);

    FeatureCache(): cur (0), feature_freelist (8192 * 16) {};
  };
}
#endif
